apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Syncs an ImageStreamTag to a Remote Docker Registry
  name: sync2registry-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        properties([
                parameters([
                        string(defaultValue: 'master', description: 'Image Tag to Sync', name: 'imageTag'),
                        string(defaultValue: '{{ namespace }}', description: 'Source ImageStream Project', name: 'dkrProject'),
                        string(defaultValue: 'https', description: 'Source ImageStream Proto', name: 'dkrProto'),
                        string(defaultValue: 'dummy', description: 'Source ImageStream Name', name: 'dkrRepo'),
                        string(defaultValue: 'true', description: 'Source TLS Verify', name: 'dkrTlsVerify'),
                        string(defaultValue: 'quay.io', description: 'Target Registry Host Address', name: 'regHostname'),
                        string(defaultValue: '{{ namespace }}', description: 'Target Registry Project', name: 'regProject'),
                        string(defaultValue: 'https', description: 'Target Registry Proto', name: 'regProto'),
                        string(defaultValue: 'dummy', description: 'Target Registry Image Name', name: 'regRepo'),
                        string(defaultValue: 'true', description: 'Target Registry TLS Verify', name: 'regTlsVerify')
                    ])
            ])
        podTemplate(label: "skopeo", name: "skopeo", cloud: 'openshift',
                    containers: [
                            containerTemplate(
                                    name: "jnlp",
                                    image: "{{ tekton_skopeo_image }}"
                                )
                       ],
                   inheritFrom: 'maven',
                   serviceAccount: '{{ jenkins_name }}') {
            node("skopeo") {
                stage('Push Image') {
                    script {
                        openshift.withCluster() {
                            def srcproto = ""
                            def dstproto = ""
                            if ($params.dkrProto == "http") {
                                $srcproto = "--src-tls-verify=false"
                            } else {
                                $srcproto = "--src-tls-verify=${params.dkrTlsVerify}"
                            }
                            if ($params.regProto == "http") {
                                $dstproto = "--dest-tls-verify=false"
                            } else {
                                $dstproto = "--dest-tls-verify=${params.regTlsVerify}"
                            }
                            def dkrHostname = "{{ docker_registry }}"
{% if k8s_flavor == 'openshift' %}
                            def srcpass = sh (
                                   script: "cat /var/run/secrets/kubernetes.io/serviceaccount/token",
                                   returnStdout: true
                               )
                            def srcuser = "{{ jenkins_name }}"
{% else %}
                            def srcpass = ""
                            def srcuser = ""
{% endif %}
                            def dst = "${params.regHostname}/${params.regProject}/${params.regRepo}:${params.imageTag}"
                            def privateTarget = false
                            def src = "${dkrHostname}/${params.dkrProject}/${params.dkrRepo}:${params.imageTag}"
                            try {
                                withCredentials([usernamePassword(credentialsId: "docker-${params.regHostname}", usernameVariable: 'REGISTRY_USERNAME', passwordVariable: 'REGISTRY_PASSWORD')]) {
                                    privateTarget = true
                                    echo "syncing ${src} to ${dst} using ${params.regRepo} token"
                                    if ($srcuser == "") {
                                        sh "skopeo copy ${srcproto} ${dstproto} docker://${src} docker://${dst} --dest-creds '${REGISTRY_USERNAME}:${REGISTRY_PASSWORD}'"
                                    } else {
                                        sh "skopeo copy ${srcproto} ${dstproto} docker://${src} docker://${dst} --src-creds '${srcuser}:${srcpass}' --dest-creds '${REGISTRY_USERNAME}:${REGISTRY_PASSWORD}'"
                                    }
                                }
                            } catch(e) {
                                if (privateTarget == false) {
                                    if ($srcuser == "") {
                                        sh "skopeo copy ${srcproto} ${dstproto} docker://${src} docker://${dst}"
                                    } else {
                                        sh "skopeo copy ${srcproto} ${dstproto} docker://${src} docker://${dst} --src-creds '${srcuser}:${srcpass}'"
                                    }
                                } else { throw e }
                            }
                        }
                    }
                }
            }
        }
    type: JenkinsPipeline
